/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/
#include "fxisam.h"

#define TMSTACK
#define QUERYON 

#define  NULLCHAR    ((char *) 0)
#define  NULLINSTR    -1
#define  INITINSTR    -2
#define  NULLFUNC    ((int(*)()) 0)
#define  DEFAULTFUNC ((int(*)()) 0)
#define  EXITFUNC    ((int(*)()) 1)

typedef int (*PFUNC)();
typedef unsigned UNINT;
typedef long PTRTYPE;
#define PTRCAST (unsigned long)
#define UNSHORT (unsigned short)


#ifndef LENNAME
#define LENNAME (18+1)
#endif


#ifndef NULL
#define NULL 0
#endif

#define  NO  0
#define  YES 1

#define  OFF 0
#define  ON  1


#ifndef EOF
#define EOF (-1)
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define  SPACE      32
#define  PERIOD     46
#define  DASH       45
#define  ZERO       48
#define  NINE       57


#define MAXPAGELEN  60 

#define FXMAXKEYLEN  240


/* user level indicaters  */
#define BEGINNER    1
#define AVERAGE     2
#define ADVANCED    3


#define RAWSIZE  (unsigned)1024
#ifdef M_I86MM
#undef RAWSIZE
#define RAWSIZE  (unsigned)512
#endif


 /* The following flags are used by the FINDREC() routine() */
#define LT 20


#define FXDIR    "FXDIR"
#define FXBIN    "FXBIN"
#define FXDATA   "FXDATA"
#define FXHELP   "FXHELP"
#define FXTERM   "FXTERM"
#define FXDATE   "FXDATE"
#define FXCURDATE  "FXCURDATE"
#define FXEDIT   "FXEDIT"
#define FXPRINT  "FXPRINT"
#define FXBIOS   "FXBIOS"
#define FXCOLOR  "FXCOLOR"
#define FXTEMP   "FXTEMP"
#define FXDBTEMP   "FXDBTEMP"

#ifdef VAXVMS
#undef  FXTERM
#define FXTERM  "FXTERM"
#endif


/*
 * The following flags are for the "stAttr" member of a "SCRTRANS"
 * struct.
 */
#define A_WRAP      0x0002          /* no display field flag */
#define A_NODISPLAY 0x0004          /* no display field flag */
#define A_REQUIRED 0x0008           /* data entry is required */
#define A_PASSWORD 0x0010           /* data entry is required */
#define A_AUTONEXT 0x0020           /* jump to next field automatically */
#define A_ALNUM    0x0040           /* allow letters and digits only */
#define A_ALPHA    0x0080           /* allow alphabetic strings only */
#define A_NUMERIC  0x0100           /* allow numeric field only */
#define A_DNSHIFT  0x0200           /* map input to lower case */
#define A_UPSHIFT  0x0400           /* map input to upper case */
#define A_SAVECOL    0x0800         /* This flag indicates seqno  */
#define A_REVERSE    0x1000         /* map input to upper case */
#define A_REVBLINK   0x2000         /* map input to upper case */
#define A_UNDERLINE  0x4000         /* map input to upper case */
#define A_ALLOWATSIGN 0x8000    

#define A2_AUTOHELP    0x0001    /* This flag indicates seqno  */
#define A2_LITERAL     0x0002    /* This flag indicates seqno  */
#define A2_CLEARDUP    0x0004
#define A2_AUTOSAVE    0x0008    /* This flag indicates seqno  */
#define A2_CAPFIRST    0x0010
#define A2_CAPALLFIRST 0x0020
#define A2_HELPSELECT  0x0040
#define A2_LOOKINPUT   0x0080
#define A2_DEFAULTNEXT 0x0100
#define A2_DEFAULTON   0x0200
#define A2_DEFAULTOFF  0x0400
#define A2_EXPAND      0x0800
#define A2_USERFLAG    0x1000         /* map input to upper case */
#define A2_2USERFLAG   0x2000         /* map input to upper case */
#define A2_NOLOOKUP    0x8000         /* map input to upper case */

#define A3_NOENTRY  0x0001           /* do not allow data entry */
#define A3_NOUPDATE 0x0002           /* do not allow data updates */
#define A3_NOQUERY  0x0004 
#define A3_NOTOTAL  0x0008   
#define A3_SKIP     0x0010          /* field should be skipped */
#define A3_XNODISPLAY  0x0020  
#define A3_NOWARNING   0x0040      /* no compile time warning */ 
#define A3_QUERYAUTOSAVE  0x0080    /* This flag indicates seqno  */

/*
 * The following flags are for the "stFormat" member of a "SCRTRANS"
 * struct.
 */
#define F_PHONE      0x0001      /* output in time-of-day format */
#define F_ZEROFILL   0x0002      /* zero fill                 */
#define F_RIGHT      0x0004      /* right-justify output using spaces */
#define F_LEFT       0x0008      /* left-justify output using spaces */
#define F_CENTER     0x0010      /* center output using spaces */
#define F_HELPSCREEN 0x0020
#define F_COMMA      0x0040
#define F_BLANKFILL  0x0080     /* blank fill                 */
#define F_ZOOMSCREEN R_ZOOMSCREEN /* MUST be same as R_ZOOMSCREEN Screen Only */
#define F_ULOOKUP    0x0200
#define F_HELPKEY    0x0400
#define F_LINENO     0x0800
#define F_NOCLEAR    0x1000   
#define F_CLEAR      0x2000   
#define F_TRUNCATE   F_CLEAR  
#define F_SEQUENCE   0x8000   

#define   SEQGAP   100

/*
 * The following bit-flags constitute to the "shFormat" member of a "SCRHEAD"
 * struct.
*/
#define R_NEWPAGE    0x0001
#define R_10PITCH    0x0002
#define R_12PITCH    0x0004
#define R_COMPRESS   0x0008
#define R_NOPRINT    0x0010
#define R_BOX        0x0020 /* Screen Only */
#define R_POPUP      0x0040 /* Screen Only */
#define R_FRAME      0x0080 /* Screen Only */
#define R_ZOOMSCREEN 0x0100 /* Screen Only */
#define R_AZOOMSCREEN 0x0200 /* Screen Only */
#define R_NOKILL      0x0400 /* Screen Only */
#define R_SNOPRINT    0x0800
#define R_RPTNOPRINT  0x1000
#define R_EVERYPAGE   0x2000
#define R_REVBAR      0x4000
#define R_NODIRCURSOR 0x8000
#define R_AUTOSAVE    R_EVERYPAGE  /*  redefine for Screen only */
#define R_NOSTACK     R_RPTNOPRINT /*  redefine for Screen only */
#define R_NOUNSTACK   R_NEWPAGE    /*  redefine for Screen only */
#define R_NOCOMPRESS  R_BOX   
#define R_AUTOPITCH12    R_REVBAR       
#define R_AUTOCOMPRESS   R_NODIRCURSOR  
#define R_UPSHIFTFIRST   R_10PITCH 

#define R2_DEFAULTON   0x0200
#define R2_DEFAULTOFF  0x0400
#define R2_OUTPUTNODATA  0x0800

/* used by datestr()  */
#define RTN_ZERO     0x0002
#define RTN_NULL     0x0004

/*
 * The following bit-flags constitute to the "shAttr" member of a "SCRHEAD"
 * struct.
*/
#define A_POINTSHOOT  0x0001
#define A_HELPSELECTSCREEN  0x0002
#define A_HELPZOOMVIEW  0x0004
#define A_ALTARYFORMAT 0x0008


/*
 *  The following values pertain to the "sfState" member of a "SCRFIELD"
 *  struct. Note lower half of sfState variable is cleared by cwmovbuf.c
 */
#define STMOD      0x0001  /* sfState only */
#define STLOCMOD   0x0002  /* sfState only
                              Local flag for accept() routine to track
                              whether screen field has been modified*/
#define STHELPMOD   0x0004 
#define STRETAIN    0x0080   /* sfState only */
#define STNONULLS   0x0100  /* sfState only
                              set by pre-processor to indicate null values
                              are disallowed. This value is equivalent
                              to RDS's value for SQLNONULL = 0400.
                           */
#define STCHGROW    0x0200  /* array with slState only */
#define STUPDPARENT 0x0400  /* array with slState only */
#define STDF_ALLVERSION  0x4000
#define LK_SELFUNC  0x1000  /*  sfState only */
#define LK_DSPFUNC  0x2000
#define LK_BEFROW   0x4000
#define LK_BEFSAVE  0x8000
#define LK_USER     0x0100  /* not used with sfState but for arg*/
#define LOOKMOVE    0x8000  /* not used with sfState but for arg*/


/* shState  */
#define STSHAUTOKEY  0x0100  /*  shState only */
#define STSHDISP     0x0800  /*  shState only */

/*
 * The following values pertain to "dhState" element in "DBHEAD"
 */
#define STDHPOS      0x0002     /* data record has been positioned  */
#define STDHSELECT   0x0004     /* DBHEAD generated from REPORTFLEX
                                   SELECT section */
#define STDHPERMTEMP 0x0010     /* DBHEAD generated from SQL
                                   SELECT INTO TEMP section */
#define STDHTEMP     0x0020     /* DBHEAD generated from SQL
                                   SELECT internal section - last duration of
                                   select  */
#define STDHRECLOCK  0x0040
#define STDHLOCK     0x0080

#define STDHREAD     0x0100
#define STDHOPEN     0x0200
#define STDVIEW      0x0400
#define STFTRANS     0x8000     /* set by ftrans flag in tables section */


/*
 *    MODES used to set flexmode global variable
 */
#define ADDMODE     1
#define CHANGEMODE  2
#define SEARCHMODE  3
#define QUERYMODE   4
#define VIEWMODE    5
#define HELPMODE    7
#define PROMPTMODE  8
#define TEXTMODE    9 
#define DUPMODE     10
#define PROMPTVIEWMODE  11 


/* maximum entries for KEYTABLE */
#define MAXKEYTABLE 50 

#ifdef MSDOS 
#define MAXHEADLIST 20 
#else
#define MAXHEADLIST 30
#endif

/* Keyword Types  */
#define K_MENU       0x0001
#define K_TABLE      0x0002
#define K_REPORT     0x0004
#define K_SCREEN     0x0008
#define K_PROCESS    0x0010
#define K_ATTRIBUTE  0x0020
#define K_ATTRTAG    0x0040

#define K_FUNC      0x1000
#define K_KEYFUNC   0x2000
#define K_VARYARG    0x4000
#define K_OPTIONARG  0x8000



#define ROWCOLSIZE  (sizeof( short))

/* defines for lookup routines - cwlookup.c */
#define ALWAYS  0x0001
#define INSIDE  0x0002
#define OUTSIDE 0x0004


/* Selection types  */
#define SEL_NO         -1
#define SEL_YES         0
#define SEL_EXIT       -2
#define SEL_NODUPS     14


#define CWBUFFER (char *)NULL


#define N_RWFILE  5

#ifdef UNIX
#undef N_RWFILE
#define N_RWFILE 10
#endif

typedef struct
{
    int  rwstatus;
    int  rwfd;
    int  rwmode;
    char rwbuf[RAWSIZE];
    unsigned  rwlastreadsize;
    int  rwnbuf;
}  RWFILE;


#define FXHELPHELP      0
#define FXHELPFIND      1
#define FXHELPWHERE     2
#define FXHELPJOIN      3 
#define FXHELPBEFOREDIT 4 
#define FXHELP2BEFOREDIT 5 

#define NBRFXN      30 

#define EMAIL_SENDMAIL  1
#define EMAIL_MAIL  2 
#define EMAIL_MAILX 3 
#define EMAIL_ANITA 10 
#define FAKE_EMAILADDRESS   "???"
