/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/
/* modes for scrollpage() */
#define R_DEFAULT     2 
#define R_BREAK       3 
#define R_EXIT        4 
#define R_FIND        12
#define R_INIT        13
#define R_LINIT       14
#define R_BACK        15
#define R_FWRD        16
#define R_UPLINE      17
#define R_DOWNLINE    18
#define R_FIRST       19
#define R_LAST        20
#define R_LINEINSERT  21
#define R_DELETE      22
#define R_ADD         23
#define R_CURDISK     24
#define R_PAGEINSERT  26
#define R_NEXT        27
#define R_LASTINIT    28


#define R_MREPAINT    30
#define R_DREPAINT    40   
#define R_DMREPAINT   41 

#define RA_MREPAINT   50
#define RA_DREPAINT   60
#define RA_DMREPAINT  61 

#define R_REPAINT     R_MREPAINT 
#define R_CURZOOM     R_DREPAINT
#define R_ZOOM        R_DMREPAINT

#define R_AREPAINT     RA_MREPAINT 
#define R_ACURZOOM     RA_DREPAINT
#define R_AZOOM        RA_DMREPAINT


/* flags for slist.slflag  */
#define CWADD     0x0001  /* ADD mode is active     (set by user args) */
#define CWCHANGE  0x0002  /* CHANGE mode is active  (set by user args) */
#define CWDELETE  0x0004  /* DELETE mode is active  (set by user args) */
#define CWSEARCH  0x0008  /* SEARCH mode is active  (set by user args and
                             program ) */
#define CWPROMPT  0x0010  /* above modes are all inactive (set by user args) */
#define CWVIEW    0x0040  /* above modes are all inactive (set by user args) */
#define CWJUMP    0x0100  /* JUMP function key is active ( set by program) */
#define CWSELECT  0x0200  /* JUMP function key is active ( set by program) */
#define CWDUP     0x0400  /* JUMP function key is active ( set by program) */
#define CWQUERY   0x0800  /* JUMP function key is active ( set by program) */




#define MAXFLFILE 10

typedef struct {
      DBHEAD *fldbhead;
      SCRHEAD *flscrhead;
      int flopentype;
      int flopenflag;
   }  FILELIST;

typedef struct {
    int fhnum;
    FILELIST fhflist[ MAXFLFILE];
    } FILEHEAD;



/* Report Image types - these are indexes into table rpttable */
#define HEADING      0
#define DETAIL       1
#define TOTAL        2
#define FOOT         3    /* Caution: used for allocating rlhlhead */


#define MAXLEXARGS   20
/* select tokens returned from function seltoken() */
#define WHERE         0
#define WHEREFUNC     1
#define WHERESCREEN   2
#define WHERESELECT   3
#define EXTRACT       4
#define ALL_EXTRACT   5
#define SUBSET        6
#define ALL_SUBSET    7
#define REJECT        8
#define ALL_REJECT    9
#define OUTER         10
#define ALL_OUTER     11
#define ON_SORT       12
#define ON_INDEX      13
#define NOSELECT      14
#define ON_UINDEX     15

#define MAXDUPNUM     5

#define RPTMAXPAGELEN  500

#define JOINHEAD  struct joinhead
#define JOINFIELD struct joinfield
#define KEYLIST   struct keylist
#define HEADLIST  struct headlist
#define INSTRUCT  struct instruct




typedef struct {
   SCRFIELD *qlscrfield; 
   short     qlFormat;/*saved from pscrtrans so can be used durring querywhere*/
   PFUNC     qlfunc;/*saved from pscrtrans  so can be used durring querywhere*/
   DBFIELD  *qldbfield; 
   short     qlbufoffs; /* must be offset and not char *buffer because
                           then mempy of structure does not work !!! */
   }  QUERYLIST;

#ifdef MSDOS
#define MAXQUERYLIST    12 
#define MAXQUERYBUFFER  120 
#endif

#ifndef MSDOS
#define MAXQUERYLIST     20 
#define MAXQUERYBUFFER  200 
#endif


typedef struct {
    int       qhNquerylist;
    QUERYLIST qhquerylist[MAXQUERYLIST];
    int       qhNquerybuffer;
    char      qhquerybuffer[MAXQUERYBUFFER]; 
    int       qhqueryactiveflag;
    int       qhdefaultboolflag;
    long      qhmatchcount;  /* -1 if no optim file created */      
    DBALTINDEX qhDbaltindex;
    DBINDEX   *qhdbindexoptim;
    int       qhlowmode;
    int       qhhighmode;
    int       qhlowsizekey;
    int       qhhighsizekey;
    char      qhlowkey[FXMAXKEYLEN];
    char      qhhighkey[FXMAXKEYLEN];
}  QUERYHEAD;

typedef struct {
    int qlsavequeryflag;
    QUERYHEAD *qloldqueryhead;
    QUERYHEAD *qloldAqueryhead;
    }  QLIST;


INSTRUCT {
       short inToken;  /* D = DataBase field  S = Screen field
                                              X = Select Screen field
                          K = Constant        O = Operator
                       */
       char *inFldptr;
       short inType;
       short inLength;
       char *inBuffer;        /* "C" format !!!  */
      };



  /* join fields between parent and child */
JOINFIELD {

      /** PARENT or SELECT fields ***/
      DBFIELD *jfPdbfield;
      short    jfPtype;
      short    jfPlength;
      char    *jfPbuffer;     /* INFORMIX format  -
                                 points directly to disk field buffer
                                 OR points to low select value */

      char    *jfPhighbuf;    /* INFORMIX format -
                                 points to high select value */


      /*** CHILD fields ***/
      DBFIELD *jfCdbfield;
      short    jfCtype;
      short    jfClength;
      char    *jfCbuffer;    /* INFORMIX format -
                                points directly to disk field buffer */

    } ;


  /* joined files */
JOINHEAD {
      int        jhtype;      /* extract, merge, subset, reject */
      DBHEAD    *jhdbhead;
      DBINDEX   *jhdbindex;
      DBHEAD    *jhjoinhead;
      int        jhjfnum;              /* number of significant joinfields */
      JOINFIELD *jhjoinfield;          /* join fields from PARENT and CHild */
      int        jhjmnum;              /* number of significant joinfields */
      JOINFIELD *jhjoinmap;            /* join fields from  */
      int        jhkeysize;            /* significant keysize calculated from
                                          JOINFIELD  */
      int        jhduppath;
      INSTRUCT  *jhinstruct;

      char      *jhbuffer;
      short      jhreadmode;
      int        jhstate;
      JOINHEAD  *jhchildlist[ 10];
      int        jhclear;
      int      (*jhwherefunc)();
    };



 /* Primary file index described here. Used for determining
    control breaks */
KEYLIST {
      char    *klOldbuf;    /* INFORMIX format -
                               points to rlkeybuf in RLIST structure
                               (unless converted date) */
      char    *klNewbuf;    /* INFORMIX format -
                               points directly to disk field buffer
                               (unless converted such as date) */
      int      klType;      /* Type of key for testing */
      int      klLength;    /* Length of key for testing */
      int      klConvert;   /* YES/NO */
      };

HEADLIST {
    HEADLIST *hlNext;      /* Next HEADLIST in order */
    HEADLIST *hlPrev;      /* Previous HEADLIST in order */
    SCRHEAD *hlScrhead;   /* Pointer to header */
    int      hlType;      /* Image type: HEADING, DETAIL, SUBTOTAL, etc. */
    DBFIELD *hlBrkfield;  /* Pointer to Break field for this header */
    int      hlBrklen;    /* Total length of all key fields previous
                             to break field plus
                             significant length of the break field */
    int      hlBrkConvert; /* YES or No flag indicating whether date
                              should be converted to ascii before
                              Break test  */
    char  *hlBuffer;          /* screen buffer */
    char **hlRowbuf;
    int      (*hlbefprint)();
    int      (*hlaftprint)();
    };

#define MAXFXRPTMSG 28   /* 20  */
#define MAXFXRPTMSGPROMPT 12 
#define MAXEMAILMSG 14  /* 8  */
#define SIZE_USERCODE 10 
#define SIZE_MSGCODE 8
#define SIZE_EMAIL  60
#define SIZE_MSG 75 

typedef struct {
    char toname[40+1];
    char toemail[100+1];
    char ccemail[100+1];
    char bcemail[100+1];
    char fromname[40+1];
    char fromemail[100+1];
    char subject[100+1];
    char attachments[100+1];
    char attachname[50+1];
    char filepath[50+1];
    char faxphone[25+1];
    char exportformat[1+1];
    char signatureflag[1+1];
    char msgcode[SIZE_MSGCODE+1];  /* set from application */
    char msg[MAXFXRPTMSG][SIZE_MSG+1];
    }  FXRPTVAR;


typedef struct {
    char usercode[SIZE_USERCODE+1];
    char msgcode[SIZE_MSGCODE+1];
    char email[SIZE_EMAIL+1];
    char msg[MAXEMAILMSG][SIZE_MSG+1];
    } EMAILUSER;

typedef struct {
    char msgcode[SIZE_MSGCODE+1];
    char msg[MAXEMAILMSG][SIZE_MSG+1];
    } EMAILMSG;

typedef struct {
    char       rlrptname[ 10];
    int        rljhnum;
    JOINHEAD   rljoinhead[ 10];
    int        rldupnum;
    JOINHEAD  *rlduphead[ MAXDUPNUM];  /* Max levels for dups is 5.
                                  JOINHEAD pointers are in hiearchial
                                  order for one lineage  */
    int        rlduppathmax;
    int        rlkeynum;
    KEYLIST    rlkeylist[ NPARTS];
    int        rlmaxbrklen;      /* Maximum length of key used for Break testing.
                                    0 - means no breaks for report */
    int        rlbrklen;         /* Set by chkbreak  */
    char       rlkeybuf[ FXMAXKEYLEN];   /* Storage area for previous key info */
    FILEHEAD   rlfilehead;
    HEADLIST   *rlhlhead[ FOOT + 1]; /* Head of link list for
                                        each image type ( header,
                                        detail, total, etc.)  */
    int        rlhlnum;              /* Number of rlheadlist */
    HEADLIST   rlheadlist[MAXHEADLIST];    /* List of all Headers in no special order */
    int        rljnum;              /* Number of rlheadlist */
    JOINFIELD *rljoinstack;      /* To replace gjoinfield in cwselect.c    */
    int        rlinsnum;              /* Number of rlheadlist */
    INSTRUCT  *rlinstack;      /* To replace ginstruct in cwselect.c     */
    int        rlbufnum;              /* Number of rlheadlist */
    char      *rlbufstack;      /* To replace global gkeybuf in cwselect.c */
    int        rllineno;
    int        rlpageno;
    int        rlpagelen;
    int        rlprintlen;
    int        rlfootlen;
    SCRHEAD   *rlscrquery;   /* Select screen header */
    SCRFIELD  *rlscrpage;    /* screen field where page number is */
    long       rlrecno;
    int        rleof;
    FILE      *rlrptout;  /* Output FILE descriptor  */
   int      (*rlaftselect)();
   int      (*rlselect)();
   int      (*rlbefselect)();
   int      (*rlbefjoin)();
   int      (*rlaftjoin)();
   int      (*rlwherefunc)();
   DBHEAD   *rlonhead;
   DBINDEX  *rlonindex;
   short     rlontype;
} RLIST;




typedef struct {

    RLIST    *slrlist;
    int       slscrtype;   /* screen tyeps  */
    JOINHEAD *slscrjoin;
    JOINHEAD *slaryjoin;
    SCRHEAD  *slscrhead;   /* current screen */
    SCRHEAD  *slscrsearch;   /* current screen */
    char      slscrnext;     /* 'K' = key, 'S' = Search screen */
    int       slcount;     /* number of screens in slscrlist */
    SCRHEAD  *slscrlist[10];   /* current screen */
    SCRFIELD *slscrfirst;  /* first field of current screen */
    SCRFIELD *slscrlast;   /* last field of current screen */
    int       slnkeys;           /* Number of KEY fields  */
    SCRFIELD *slkeyfield[ 10];     /* screen KEY fields  */
    int       slMode;      /* ADDMODE, CHANGEMODE */
    int       slState;     /* Modify flag   */
    int       slflag;      /* Mode flag for permisable modes : i.e.
                              CWADD, CWCHANGE, etc  */
    int       slNumrow;  /* Number of active array lines on the screens  */
    char    **slkeybuf;  /* Key buffers for each array line on the screen */

    SCRFIELD *slrelscr;    /* Screen field where relative number stored */
    long      slrelnum;    /* relative row number of top array screen row */
    long      slrelmax;    /* maximum rows in screen array */

    /* Sequence Info  */
    int       slseqtype;    /* sequence number */
    int       slseqmode;    /* sequence number */
    int       slseqcount;    /* Number of sequence fields on screen */
    DBFIELD  *slseqdb[2];
    SCRFIELD *slseqscr[2];    /* screen field where sequence number stored */
    long      slseqcurnum[2];    /* sequence number */
    long      slseqnextnum[2];    /* sequence number */
    int       slseqgap[2];

    /* Database Info  */

    DBHEAD   *sldbhead;
    DBINDEX  *sldbindex;
    int       slnkeyparts;/* significant keysize  ( if -1 then use total key) */
    int       slsizkey; /* significant keysize  ( if -1 then use total key) */
    char     *sllowkey; /* pointer to key buffer with low end of valid range */
    char     *slhighkey;/* pointer to key buffer with high end of valid range */
    char      slmsgjump[90];
    char      slmodemsg[41];
    int       slmsgflag;
    int       slinit;
    int       slrestart;
    int       slexit;   
    int       sllocked;
    KEYTABLE  slkeyvalid[ MAXKEYTABLE];
    int       slprefixkey;
    SCRFIELD  *slprefixkeyscrfield;

}   SLIST;



#define MAXGARG  20

typedef struct {

        /* --- Database pointers --- */

        DBHEAD  *gdbhead;
        DBFIELD *gdbfield;
        DBINDEX *gdbindex;
        char    *gdbbuffer;
        char    *gdbkeybuf;

          /* --- Screen pointers --- */

        SCRHEAD  *gscrhead;
        SCRFIELD *gscrfield;
        SCRFIELD *gscrfmtfield; /* only set in fxaccept() for stFmtfield function */ 
        char     *gscrbuffer; /* points to starting position of entire screen */
        char     *gsnewfld;   /*points to field's starting position in temporary */
                              /* buffer. Temp buffer is where data collected from */
                              /* screen is stored. */
        SLIST    *gslist;
        RLIST    *grlist;
        FILE     *grptout;

        struct decimal   gdecstr;
        int      gargc;
        char    **gargv;

} GLOBAL;



/* TEST */
/*
#define TEST
*/
#ifdef TEST
#include <signal.h>
#endif


