

#if defined INFORMIX6 || defined INFORMIXALLVERSION
#define TBLPATHSIZE 256
#else
#define TBLPATHSIZE 64 
#endif

typedef struct {
     char      st_tabname[LENNAME];
     char      st_owner[8 + 1];
     char      st_dirpath[TBLPATHSIZE + 1];
     long      st_tabid;
     int       st_rowsize;
     int       st_ncols;
     int       st_nindexes;
     long      st_nrows;
     long      st_created;
     long      st_version;
     char      st_tabtype[1 + 1];
     char      st_audpath[TBLPATHSIZE + 1];
     } SYSTABLE;

 typedef struct {
     char      sc_colname[LENNAME];
     long      sc_tabid;
     int       sc_colno;
     int       sc_coltype;
     int       sc_collength;
     } SYSCOLUMNS;

 typedef struct {
     char      si_idxname[LENNAME];
     char      si_owner[8 + 1];
     long      si_tabid;
     char      si_idxtype[1 + 1];
     char      si_clustered[1 + 1];
     int       si_part[ NPARTS];
     } SYSINDEXES;

 typedef struct {
     char      so_objtype[1 + 1];
     char      so_owner[8 + 1];
     char      so_name[LENNAME];
     long      so_tabid;
     char      so_state[1 + 1];
     } SYSOBJSTATE;


#if defined INFORMIX6 || defined INFORMIXALLVERSION
#define SZ_TABLES (561+5)
#else
#define SZ_TABLES (177+5)
#endif
#define SZ_COLUMNS (28+1)
#define SZ_INDEXES (48+4)
#define SZ_OBJSTATE (32+4)



extern int fdstbl;
extern char stblrec[];
extern SYSTABLE systables;


extern int fdscol;
extern char scolrec[];
extern SYSCOLUMNS syscolumns;

extern int fdsidx;
extern char sidxrec[];
extern SYSINDEXES sysindexes;

extern int fdsobj;
extern char sobjrec[];
extern SYSINDEXES sysobjstate;

extern DBHEAD *psystables;
extern DBHEAD *psyscolumns;
extern DBHEAD *psysindexes;
extern DBHEAD *psysobjstate;
extern DBHEAD *psystbauth;
extern DBHEAD *psysusers;





