/*
----------------------------------------------------------------------
configuration options
----------------------------------------------------------------------

         +----------------------------------------------------+
         |  Worldwide Copyright (c) Byte Designs Ltd (1996)   |    
         |                                                    |
         |               20568 - 32 Avenue                    |
         |               LANGLEY, BC                          |
         |               V3A 4P5 CANADA                       |
         |                                                    |
         | Sales: sales@byted.com  Support: support@byted.com |
         | Phone: (604) 534 0722   Fax: (604) 534 2601        |
         +----------------------------------------------------+
                            Version 6.11
 
----------------------------------------------------------------------
*/

/* configuration options - adjust as required --------------------- */

/* features */
#define ISADMIN     1                   /* global administration */
#define ISAUDIT     1                   /* 0:off 1:standard */
#define ISLOGGING   1                   /* 0:off 1:standard */
#define ISVARIABLE  1                   /* 0:off 1:std 2:pack */
#define ISLOCKING   2                   /* 0:off 1:old 2:std 3:lck */
#define ISDUPLOCKS  0                   /* honour locks in dup opens */
#define ISDECLARE   1                   /* declare parameters */
#define ISDATAVOID  0                   /* void data pointers */
#define ISCUSTOM    0                   /* include custom extensions */
#define ISBERKELY   0                   /* 0:memcpy() 1: bcopy() */

/* values */
#define ISIDXBLK    1024                /* default index block size */
#define ISDUPLEN    4                   /* default duplicate width */
#define ISMAXIDX    16                  /* indexes per file */ /* DBGU */
#define ISMAXPARTS  8                  /* parts per key */
#define ISMAXKEY    240                /* bytes per key */
#define ISMAXBUF    20                  /* buffers per index */
#define ISERRBASE   100                 /* start error codes at */

/* threadsafe configuration -------------------------------------- */

/* 0 - disabled
   1 - SunOS
   2 - Solaris */
   
#define ISTHREADED  0

/* the rest are internals ---------------------------------------- */

/* not configurable */
#define ISDYNAMIC   0                   /* not available */
#define ISMIFCODE   0                   /* not available */

/* conflicting options check */
#if( ISLOGGING > 0 && ISADMIN == 0 )
#pragma error /* logging requires the administration facility */
#endif

