/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to INFOFLEX ,
* INC. . The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of INFOFLEX,INC..
*
* COPYRIGHT (c) 1986 INFOFLEX , INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/
/*
   Differences:
    PERMISSIONS are not implemented.
    SQL dictionary used.
    dbselect(): For DBOPEN 2nd argument is a list of filenames or a '.pic' file.
    dbselfield(): ACCPRIMARY argument is NOT supported.   
    dbalias():  This capability is obtained thru dbselect().
    ACE clone available  from ALLEGRO Tech.


*/

#include "flex.h"
#include "fxsyscat.h"
#include "fxdball.h"
#include <setjmp.h>
#include <signal.h>

#define MAX_IDX 8

HDHEAD ghdhead;
char msgbuf[ 300];
DBHEAD *gdbdhp();
DBFIELD *gdbdfp();
DBINDEX *gdbdip();
DBINDEX *getrdcp();
extern int strcmp();
extern char *strfind();


static int dbopenflag = NO;
static int dbtypeflag = 0;
static DBINDEX *lastpdbindex = NULLDI;

int sigcall = NO;
int sigflag;
jmp_buf dbjmp_buf;

dbselect( flag, name)
int flag;
char *name; /* picname */
{
    DBHEAD *pdbhead;
    int openmode;

    switch( flag & 0x00ff) {

        case DBOPEN:
            cwvar3(); /* dummy function for so linker includes cwvar3.c  */
            dbsetpath( cwdbpath);  /* set default paths */
            fmisaminit();
            vtsetnull();
            cwsymbol = YES;
            fxsetalign();
            gettoday( &curdate);
            load_syscat();
            if ( dbopenflag )
                return( 6002);
            dbopenflag = YES;
            if (name == NULLCHAR) 
                return( 6001);
            dbtypeflag = 0;
            if (strfind( name, ".pic", strcmp) != NULLCHAR) 
               dbtypeflag = 1;
            if (strfind( name, ".dbs", strcmp) != NULLCHAR) 
               dbtypeflag = 2;
            if (dbtypeflag == 0)  {
               fmxload(name);
               stagealloc();
               }
            else if (dbtypeflag == 1)  {
               loadpic( name);
               }
            break;

        case DBCLOSE:
            if ( dbopenflag == NO)
                return( 6000);
            dbopenflag = NO;
            if (dbtypeflag == 0) {
               fmunload();
               stagefree();
               }
            else if (dbtypeflag == 1)  {
               unloadpic();
               }
            dbtypeflag = 0;
            break;
        case FILEOPEN:
            if ( dbopenflag == NO)
                return( 6004);
            if (NULLDH == (pdbhead = gdbdhp( name)) ) 
                return(6001);
            switch ( flag & 0xff00) {
                  case READWRITE:
                      openmode = ISINOUT+ISMANULOCK;
                      break;
                  case READONLY:
                      openmode = ISINPUT+ISMANULOCK;
                      break;
                  case EXCLUSIVE:
                      openmode = ISINOUT+ISEXCLLOCK;
                      break;
                  default:
                      return(6013);
                  }
            if ( 0 > fmopen( pdbhead, openmode) ) 
                return(iserrno + 6000);
            if (fmstart( pdbhead, NULLDI, 0, ISFIRST) < 0)  {
                if (iserrno != 110 && iserrno != 111)  
                     return(iserrno + 6000);
                }
            break;
        case FILECLOSE:
            if ( dbopenflag == NO)
                return( 6004);
            if (NULLDH == (pdbhead = gdbdhp( name)) ) 
                return(6001);
            if ( 0 > fmclose( pdbhead) ) {
                return(iserrno + 6000);
                }
             break;

        default:
          return( 6014);
        }

    return( 0);
}


dbfile( filename, numflds, recsize, perms)
char *filename;  /* PASSED IN */
short *numflds; /* RETURNED */
short *recsize; /* RETURNED */
short *perms;  /* NOT USED */
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    *numflds = pdbhead->dhDfnum + getdcn(pdbhead);
    *perms = 0;
    *recsize = pdbhead->dhLength; 

    return( 0);
}

dbnfile( filenum, filename, numflds, recsize, perms)
short filenum;  /* PASSED IN */
char *filename;
short *numflds; /* RETURNED */
short *recsize; /* RETURNED */
short *perms;  /* NOT USED */
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if ( filenum >= ghdhead.hdDhnum) 
       return(6001);

    pdbhead = getndhp( filenum);

    strcpy( filename, getrtxt(pdbhead->dhName));
    *numflds = pdbhead->dhDfnum + getdcn(pdbhead);
    *recsize = pdbhead->dhLength; 
    *perms = 0;

    return( 0);
}


dbncomposite( ncomp, filename, compname, partname, ptype, plen, pperms)
short ncomp;  /* PASSED IN */
char *filename, *compname, *partname;
short *ptype; /* RETURNED */
short *plen; /* RETURNED */
short *pperms;  /* NOT USED */
{
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    pdbindex = gdbdip( pdbhead, compname);
    if (pdbindex == NULLDI) 
       return( 6007);
    if (pdbindex->diDfnum <= 1) 
       return( 6007);

    if (ncomp >= pdbindex->diDfnum) 
       return( 6044);

    pdbfield = getrdfp( pdbhead, pdbindex->diDfindex[ ncomp] - 1);

    strcpy(partname, getsymptr( pdbfield));
    *ptype  = pdbfield->dfType;
    *plen   = pdbfield->dfBytes;
    *pperms = 0;

    return( 0);
}


dbnfield( fldnum, filename, fldname, type, len, perms)
int fldnum; /* PASSED IN */
char *filename, *fldname; /* RETURNED */
short *type, *len, *perms; /* RETURNED */
{
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if ( fldnum < 0 || fldnum >= pdbhead->dhDfnum + getdcn( pdbhead) )
       return( 6041);

    if ( fldnum < pdbhead->dhDfnum) {
         pdbfield = getrdfp( pdbhead, fldnum); 
         strcpy( fldname, getsymptr( pdbfield));
         *type    = pdbfield->dfType;
         *len     = pdbfield->dfBytes;
         *perms = 0;
         }
    else {
        pdbindex = getrdcp( pdbhead, fldnum - pdbhead->dhDfnum);
        strcpy( fldname, getrtxt( pdbindex->diName));
        *type = COMPOSTYPE;
        *len = pdbindex->diDfnum;
        *perms = 0;
        }

    return( 0);
}


dbindex(  filename, fldname, idxtype)
char *filename, *fldname; /* PASSED IN */
short *idxtype; /* RETURNED */
{
    int i;
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;
    int fldnum; 

    *idxtype = 0;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    *idxtype = 0;
    pdbfield = gdbdfp( pdbhead, fldname); 
    if (pdbfield == NULLDF)  {
       pdbindex = gdbdip( pdbhead, fldname); 
       if (pdbindex != NULLDF && pdbindex->diDfnum > 1)   {
           lastpdbindex = pdbindex;
           if (pdbindex->diType ==  'U') 
              *idxtype = 1;
           else if (pdbindex->diType ==  'D') 
              *idxtype = 2;
           return(0);
           }
       return(6007);
       }

    fldnum = getpdfr( pdbhead, pdbfield) + 1;
    for (i=0,pdbindex=pdbhead->dhDbindex;i < pdbhead->dhDinum; ++i,++pdbindex){
         if (pdbindex->diDfnum == 1 && pdbindex->diDfindex[0] == fldnum) 
            break;
        } 

    lastpdbindex = pdbindex;

    if (i >= pdbhead->dhDinum) 
       *idxtype = 0;
    else if (pdbindex->diType ==  'U') 
       *idxtype = 1;
    else if (pdbindex->diType ==  'D') 
       *idxtype = 2;

    return(0);
}


dbstructview( filename, fieldlist, n)
    char *filename;
    struct dbview *fieldlist;
    int n;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
       return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (0 > fmstructview( pdbhead, fieldlist, n, (char *)0) )
       return(6005);

    return(0);
}


dbselfield( filename, fieldname, flag)
   char *filename;
   char *fieldname;
   int flag;
{
    DBHEAD *pdbhead;
    DBINDEX *pdbindex = NULLDI;
    DBFIELD *pdbfield = NULLDF;
    short idxtype;
    int rtn;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6008);

    switch( flag) {
        case ACCKEYED:
             /* Check if index exists as a field name */
            pdbfield = gdbdfp( pdbhead, fieldname);
            if (pdbfield != NULLDF) {
                rtn = dbindex( filename, fieldname, &idxtype);
                if ( rtn != 0) 
                    return(rtn);
                if (idxtype == 0) 
                   return(6026);
                pdbindex = lastpdbindex;
                break;
                }
             
            /* Check if index exists as an index name */
            pdbindex = gdbdip( pdbhead, fieldname);
            if (pdbindex == NULLDI)
                return(6007);
             break;

        case ACCSEQUENTIAL:
             pdbindex = NULLDI;
             break;
/*
        case ACCPRIMARY:
             pdbindex = pdbhead->dhDbindex;
             for (i =0; i < pdbhead->dhDinum; ++i, ++pdbindex) {
                if (pdbindex->diType == 'U')
                  break; 
                }
             if (i >= pdbhead->dhDinum)
                pdbindex = NULLDI;
             break;
*/
        default:
             return(6014);
        }


    if (fmstart( pdbhead, pdbindex, 0, ISFIRST) < 0) { 
       if (iserrno != 111 && iserrno != 110)
          return(iserrno + 6000);
       }


    return(0);
}


dbaddindex( filename, fldname, dupsorno)
char *filename, *fldname;
short dupsorno;
{
    int i;
    int rtn = 0;
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;
#ifdef UNIX
    extern char *getlogin();
#endif

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (NULLDF == (pdbfield = gdbdfp( pdbhead, fldname)) ) 
       return(6007);

    if (pdbhead->dhFldesc < 0)
       return(6015);

    if (NULLDI != (pdbindex = gdbdip( pdbhead, fldname)) ) 
       return(6047);

    if (pdbhead->dhDinum >= MAX_IDX) 
       return( 6040);  /* too many indexes */

    pdbindex = (DBINDEX *)((char *)pdbhead + sizeof(DBHEAD));
    if (pdbhead->dhDinum > 0)
         pdbindex = pdbhead->dhDbindex + pdbhead->dhDinum;
    strcpy( pdbindex->diName, fldname);
    pdbindex->diType = 'U';
    if (dupsorno)  
        pdbindex->diType = 'D'; 
    pdbindex->diDhindex = getpdhn( pdbhead);
    pdbindex->diDfnum = 1;
    pdbindex->diDfindex[0] = getpdfr(pdbhead, pdbfield)  + 1;
    pdbindex->diLength = pdbfield->dfBytes;

    /* update system catalogs */
    if (x_sysopen(YES) < 0) {
        rtn = 6200 + iserrno;
        goto addexit;
        }
    if (findstbl( filename) < 0) {
        rtn = 6200 + iserrno;
        goto addexit;
        }

    if (fmaddindex( pdbhead, pdbindex) < 0) {
       if (iserrno == 100)  { /* Duplicate key */
           rtn = 6048;
           goto addexit;
           }
       if (iserrno == 106) {  /* Not opened with exclusive lock */  
           rtn = 6046;
           goto addexit;
           }
       if (iserrno == 108){    /* Index already exists */
           rtn = 6047;
           goto addexit;
           }
       if (iserrno == 103){   /* BAD key */
           rtn = 6050;
           goto addexit;
           }
       rtn = 6000 + iserrno;
       goto addexit;
       }

    ++(pdbhead->dhDinum);
    ++(systables.st_nindexes);
    if (fmrewcurr(psystables) < 0) {
       rtn = 6200 + iserrno;
       goto addexit;
       }
     strcpy( sysindexes.si_idxname, pdbindex->diName);
#ifdef UNIX
     strcpy( sysindexes.si_owner, getlogin());
#endif
#ifdef MSDOS 
     strcpy( sysindexes.si_owner, "pcuser");
#endif
     sysindexes.si_tabid       = systables.st_tabid;
     sysindexes.si_idxtype[0]  = pdbindex->diType;
     sysindexes.si_clustered[0]= '\0';
     for ( i = 0; i < NPARTS; ++i )
        sysindexes.si_part[ i]  = 0;
     for ( i = 0; i < pdbindex->diDfnum; ++i )
        sysindexes.si_part[ i]  = pdbindex->diDfindex[i];
    if (fmwrite( psysindexes) < 0) {
       rtn = 6200 + iserrno;
       goto addexit;
       }

 addexit:
    sysclose();

    return(rtn);
}

dbdelindex( filename, fldname)
char *filename, *fldname;
{
    int rtn = 0;
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (NULLDF == (pdbfield = gdbdfp( pdbhead, fldname)) ) 
       return(6007);

    if (pdbhead->dhFldesc < 0)
       return(6015);

    if (NULLDI == (pdbindex = gdbdip( pdbhead, fldname)) ) 
       return(6047);

    /* update system catalogs */
    if (x_sysopen(YES) < 0) {
        rtn = 6200 + iserrno;
        goto addexit;
        }
    if (findstbl( filename) < 0) {
        rtn = 6200 + iserrno;
        goto addexit;
        }
    if (findsidx( fldname, systables.st_tabid) < 0) {
        rtn = 6200 + iserrno;
        goto addexit;
        }


    if (fmdelindex( pdbhead, pdbindex) < 0) {
       if (iserrno == 106) {  /* Not opened with exclusive lock */  
           rtn = 6046;
           goto addexit;
           }
       if (iserrno == 103){   /* BAD key */
           rtn = 6050;
           goto addexit;
           }
       rtn = 6000 + iserrno;
       goto addexit;
       }

    --(pdbhead->dhDinum);
    --(systables.st_nindexes);
    if (fmrewcurr(psystables) < 0) {
       rtn = 6200 + iserrno;
       goto addexit;
       }
    if (fmdelcurr(psysindexes) < 0) {
       rtn = 6200 + iserrno;
       goto addexit;
       }

 addexit:
    sysclose();

    return(rtn);
}

dbfind( filename, flag, value, length, recbuf)
   char *filename;
   int flag;
   char *value;
   int *length;
   char *recbuf;
{
    int i, j;
    int ismode;
    DBHEAD *pdbhead;
    DBINDEX *pdbindex;
    DBFIELD *pdbfield;
    char *fieldptr;
    char fieldname[18 +1];
    struct dbview *pdbview;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6015);

    if (pdbhead->dhView == (char *)0) 
       return(6016);

    switch( flag & 0xff)  {
         case COMPARISON:
         case EQUAL:
              ismode = ISEQUAL;
              break;
         case GTEQ:
              ismode = ISGTEQ;
              break;
         case GREATER:
              ismode = ISGREAT;
              break;
         case FIRST:
              ismode = ISFIRST;
              break;
         case LAST:
              ismode = ISLAST;
              break;
         case CURRENT:
              ismode = ISCURR;
              break;
         case NEXT:
              ismode = ISNEXT;
              break;
         case PREVIOUS:
              ismode = ISPREV;
              break;
         default:
              return( 6014);
         }

    /* move value into recbuf */
    if (ismode == ISEQUAL || ismode ==  ISGTEQ || ismode == ISGREAT) {
        pdbindex = (DBINDEX *)pdbhead->dhDicurrent;
        if (pdbindex == NULLDI)
           return(6045);
        if (pdbindex->diDfnum == 1) {
            if (value == (char *)0)
               return( 6010);
            /* move value to Data Base Buffer */
            pdbfield = getrdfp( pdbhead, pdbindex->diDfindex[0] - 1);
            putdf( value, pdbfield);
            }
        if (pdbindex->diDfnum > 1) {
            /* move dbview COMPOSITE value(s) to Data Base buffer */
            for (i=0; i < pdbindex->diDfnum; ++i) {
                pdbfield = getrdfp( pdbhead, pdbindex->diDfindex[i] - 1);
                fieldptr = getsymptr( pdbfield);
                strcpy( fieldname, fieldptr);
                strcompress( fieldname);
                pdbview = (struct dbview *) pdbhead->dhView;
/*
            printf( "composite field = %s, start =%d, type=%d, len=%d\r\n", 
            pdbview->vwname, pdbview->vwstart, pdbview->vwtype, pdbview->vwlen);
*/
                for (j = 0; j < pdbhead->dhVwnum; ++j, ++pdbview) {
                    if (strcmp( fieldname, pdbview->vwname) == 0) {
                        putdf((char *) &recbuf[pdbview->vwstart], pdbfield);
                        break;
                        }

                    } /* end of inner loop */

                } /* end of outer loop */

           }  /* end of COMPOSITE */ 

       } /* end of test for ISEQUAL */


    if (flag & 0xff00)
       ismode += ISLOCK;
    if (fmread( pdbhead, ismode) < 0) { 
       switch( iserrno) {
            case 110: /* Beginning or End of file condition */
                 if (ismode == ISPREV)
                    return(6012);
                 else
                    return(6011);
            case 111: /* Record NOT found */
                 return(6010);
            case 112:  /* No current record */
                 return(6035);
            }
       return(iserrno + 6000);
       }

    fmsetview( pdbhead, recbuf, CWGETDF);
    *length = 0;  /* should be length of recbuf */

    return(0);
}


dbadd( filename, recbuf)
char *filename;
char *recbuf;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6018);

    if (pdbhead->dhView == (char *)0) 
       return(6019);

    dclrrec( pdbhead);
    pdbhead->dhVwstruct = recbuf;
    if (sigcall == NO) sigignore();
    if (fmwrcurr(pdbhead) < 0) {
       if (sigcall == NO) sigdefault();
       pdbhead->dhVwstruct = (char *)0;
       switch( iserrno) {
            case 100:  /* Duplicate values */
                 return(6017);
            }
       return(iserrno + 6000);
       }

    if (sigcall == NO) sigdefault();
    pdbhead->dhVwstruct = (char *)0;

     return(0);
}


dbupdate( filename, recbuf)
   char *filename;
   char *recbuf;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6028);

    if (pdbhead->dhView == (char *)0) 
       return(6029);

    pdbhead->dhVwstruct = recbuf;
    if (sigcall == NO) sigignore();
    if (fmrewcurr(pdbhead) < 0){
       if (sigcall == NO) sigdefault();
       pdbhead->dhVwstruct = (char *)0;
       switch( iserrno) {
            case 100:
                 return(6030);
            case 112:
                 return(6020);
            }
       return(iserrno + 6000);
       }
    if (sigcall == NO) sigdefault();
    pdbhead->dhVwstruct = (char *)0;

    return(0);
}


dbdelete( filename)
char *filename;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6021);

    if (sigcall == NO) sigignore();
    if (fmdelcurr(pdbhead) < 0){
       if (sigcall == NO) sigdefault();
       switch(iserrno) {
            case 112: /* No current Row */
                 return(6020);
            }
       return(iserrno + 6000);
       }
    if (sigcall == NO) sigdefault();

    return(0);
}


dblock( filename)
char *filename;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6023);

    if (fmlock(pdbhead) < 0){
       return(6022);
       }


    return(0);
}


dbunlock( filename)
char *filename;
{
    DBHEAD *pdbhead;

    if ( dbopenflag == NO)
         return( 6000);

    if (NULLDH == (pdbhead = gdbdhp( filename)) ) 
       return(6001);

    if (pdbhead->dhFldesc < 0)
       return(6023);

    if (fmunlock(pdbhead) < 0){
       return(-1);
       }

    if (fmrelease(pdbhead) < 0){
       return(-1);
       }

    return(0);
}



static DBHEAD *gdbdhp( filename)
char *filename;
{
   DBHEAD *pdbhead;

     errorlevel(NO);
     pdbhead = getdhp( filename);
     errorlevel(YES);
     return( pdbhead);
}

static DBFIELD *gdbdfp( pdbhead, fldname)
DBHEAD *pdbhead;
char *fldname;
{
    DBFIELD *pdbfield;

     errorlevel(NO);
     pdbfield = getdfp( pdbhead, fldname);
     errorlevel(YES);
     return( pdbfield);
}

static DBINDEX *gdbdip( pdbhead, idxname)
DBHEAD *pdbhead;
char *idxname;
{
    DBINDEX *pdbindex;

     errorlevel(NO);
     pdbindex = getdip( pdbhead, idxname);
     errorlevel(YES);
     return( pdbindex);
}

static DBINDEX *getrdcp( pdbhead, compnum)
DBHEAD *pdbhead;
int compnum;
{
    int counter;
    int compcounter = 0;
    DBINDEX *pdbindex;

   compcounter = 0;
   for (counter=0,pdbindex=pdbhead->dhDbindex;counter < pdbhead->dhDinum; ++counter, ++pdbindex) {
         if (pdbindex->diDfnum <= 1) /* IGNORE NON-COMPOSTYPE INDEXES */
            continue;
         if (compcounter == compnum)
            return( pdbindex);
         ++compcounter;
         }

    return( NULLDI);
}


static int getdcn(pdbhead)
DBHEAD *pdbhead;
{
    int counter;
    int compcounter = 0;
    DBINDEX *pdbindex;

   compcounter = 0;
   for (counter=0,pdbindex=pdbhead->dhDbindex;counter < pdbhead->dhDinum; ++counter, ++pdbindex) {
         if ( pdbindex->diDfnum <= 1) /* IGNORE NON-COMPOSTYPE INDEXES */
            continue;
         ++compcounter;
         }

     return(compcounter);
}


dbsetpath( path)
char *path;
{
    static char datapath[120];
    extern char *getenv();

    if ( path == NULLCHAR) {
       cwdbpath = getenv( "FXDATA");
       cwpgpath = getenv( "FXDATA");
       if (cwdbpath == (char *)0) {
          cwdbpath = getenv( "DBPATH");
          cwpgpath = getenv( "DBPATH");
          }
       }
    else {
       strncpy( datapath, path, sizeof( datapath) - 1);
       cwdbpath = datapath;
       cwpgpath = datapath;
       }

}

static int x_sysopen( lockflag)
int lockflag;
{
   int i;
   DBHEAD *pdbhead;

    for (i = 0; i < 3; ++i) {
        if (i == 1) continue;  /* don't need to open syscolumns */
        pdbhead = ghdhead.hdDhptr[i];
        if ( 0 > fmopen( pdbhead, ISINOUT+ISMANULOCK) )
           return( -1);
        if (lockflag == YES) {
           if (fmlock( pdbhead) < 0) 
               return( -1);
           }
       }

    sysstruct();

    return(0);
}


static stchar( src, dest, size)
char *src;
char *dest;
int size;
{
     int i;

     for ( i = 1; i <= size && *src != '\n' && *src != '\0'; ++i)
         *dest++ = *src++;

    while( i++ <= size)
       *dest++ = ' ';

    *dest = '\0';

}



/**********   S I G N A L S    ****************/


sigdefault()
{
#ifdef UNIX
    int i;
    sigflag = 0;
    for (i=1; i < NSIG; i++)
       signal( i, SIG_DFL);
#endif

#ifdef MSDOS
    sigflag = 0;
    signal( SIGINT, SIG_DFL);
#endif
}


sigignore()
{
#ifdef UNIX
    int i;
    sigflag = 0;
    for (i=1; i < NSIG; i++)
        signal( i, SIG_IGN);

    signal( SIGALRM, SIG_DFL);
    signal( SIGCLD,   SIG_DFL);
#endif

#ifdef MSDOS
    sigflag = 0;
    signal( SIGINT, SIG_IGN);
#endif
}



siginit()
{
#ifdef UNIX
    extern int sig_int();
    extern int sig_hup();
    extern int sig_quit();
    extern int sig_term();
    int i;
    sigcall = YES;
    sigflag = 0;
    for (i=1; i < NSIG; i++)
        signal( i, SIG_DFL);
   signal( SIGINT,  sig_int);
   signal( SIGHUP,  sig_hup);
   signal( SIGQUIT, sig_quit);   
   signal( SIGTERM, sig_term);  
#endif


#ifdef MSDOS
    sigcall = YES;
    sigflag = 0;
    signal( SIGINT, SIG_DFL);
#endif
}

sig_int( signo)
int signo;
{
   sigflag = signo;
   signal( signo, sig_int);
}

sig_hup( signo)
int signo;
{
   sigflag = signo;
   signal( signo, sig_hup);
}

sig_quit( signo)
int signo;
{
   sigflag = signo;
   signal( signo, sig_quit);
}

sig_term( signo)
int signo;
{
   sigflag = signo;
   signal( signo, sig_term);
}


sigproc()
{
    if (sigflag == SIGINT) {
       sigflag = 0;
       /* longjump( dbjmp_buf, 3); */
       return;
       } 

    sigcleanup();
}

