

#include <stdio.h>

#define YES 1

static char gfilename[50];
 

typedef struct {
    char indexname[50];
    char helptype[50];
    char helpscreen[50];
    } HELPSTRUCT;

HELPSTRUCT helpstruct[] = { 
/**
    {"apmopen.apmopeninvno",        "helpselect", "helppbobv"},
    {"apmopen.apmopenvennoinvno",   "helpselect", "helppbobv"},
**/
    {"glbgje.glbgjebatch",        "helpselect", "hlpgbje"},
    {"glmgje.glmgjebatch",        "helpselect", "hlpgmje"},
    {"glmcoa.glmcoaglcode",        "helpselect", "hlpgl"},
    {"itemm.itemm",        "helpselect", "hlpxitem"},
    {"iimbd.iibmd",        "helpselect", "hlpxibmd"},
    {"quetable.quetablecode",        "helpselect", "hlpque"},
    {"slmsale.slmsale",        "helpselect", "hlpsale"},
    {"slmship.slmshipcusno",        "helpselect", "hlpsship"},
    {"slmtax.slmtaxtaxcode",        "helpselect", "hlptax"},
    {"slmterm.slmtermtermcode",        "helpselect", "hlpterm"},
    {"pymemp.pymempempno",        "helpselect", "hlpemp"},
    {"pymdiv.pymdivdivno",        "helpselect", "hlpemp"},
    {"pymearn.pymearncode",        "helpselect", "hlpemp"},
    {"pymded.pymdedcode",        "helpselect", "hlpemp"},
    {"pymtax.pymtaxcode",        "helpselect", "hlpemp"},
    {"apmopen.apmopeninvno",        "helpselect", "hlppbop"},
    {"apmopen.apmopenvennoinvno",   "helpselect", "hlpven"},
    {"apbinv.apbinvbatch",          "helpselect", "hlppbinv"},
    {"apbadj.apbadjbatch",          "helpselect", "hlppbadj"},
    {"apbchk.apbchkbatch",          "helpselect", "hlppbchk"},
    {"apminv.apminvinvno",          "helpselect", "hlppminv"},
    {"apminv.apminvvennoinvno",     "helpselect", "hlpven"},
    {"apmadj.apmadjinvno",          "helpselect", "hlppmadj"},
    {"apmadj.apmadjvennoinvno",     "helpselect", "hlpven"},
    {"apmven.apmvenvenno",          "helpselect", "hlpven"},
    {"apmven.apmvenname",           "helpselect", "hlpven"},
    {"arbinv.arbinvbatch",          "helpselect", "hlprbinv"},
    {"arbadj.arbadjbatch",          "helpselect", "hlprbadj"},
    {"arbchk.arbchkbatch",          "helpselect", "hlprbchk"},
    {"arminv.arminvinvno",          "helpselect", "hlprminv"},
    {"arminv.arminvcusnoinvno",     "helpselect", "hlpcus"},
    {"armadj.armadjinvno",          "helpselect", "hlprmadj"},
    {"armadj.armadjcusnoinvno",     "helpselect", "hlpcus"},
    {"armopen.armopeninvno",        "helpselect", "hlprbop"},
    {"armopen.armopencusnoinvno",   "helpselect", "hlpcus"},
    {"armcus.armcuscusno",          "helpselect", "hlpcus"},
    {"armcus.armcusname",           "helpselect", "hlpcus"},
    {"armcus.armcussort",           "helpselect", "hlpcus"},
    {"glbinv.glbinvbatch",          "helpselect", "hlpgbinv"},
    {"glminv.glminvbatch",          "helpselect", "hlpgminv"},
    {"glbinvs.glbinvsbatch",        "helpselect", "hlpgbinvs"},
    {"glminvs.glminvsbatch",        "helpselect", "hlpgminvs"},
    {"glbinvr.glbinvrbatch",        "helpselect", "hlpgbinvr"},
    {"glminvr.glminvrbatch",        "helpselect", "hlpgminvr"},
    {"glmform.glmform",             "helpselect", "hlpform"},
    {"tbmjob.tbmjobjobno",          "helpselect", "hlpjob"},
    {"slmship.slmshipshipcode",     "helpselect", "hlpxship"},
    {"apsven.apsvenvenno",          "helpselect", "hlpxsven"},
    {"arscus.arscuscusno",          "helpselect", "hlpxscus"},
  };
int n_helpstruct;

typedef struct {
    char helpscreen[25];
    } HELPSCREENLIST;
HELPSCREENLIST helpscreenlist[50];
int n_helpscreenlist;

main(argc, argv)
int argc;
char *argv[];
{
    FILE *fp1;
    int c;
    int i;
    static char buffer[1000];
    

    if (argc < 2) {
      printf("Missing filename argument\r\n");
      exit(1);
      }

    strcpy(gfilename, argv[1]);
    n_helpstruct = sizeof(helpstruct)/sizeof(HELPSTRUCT);
    n_helpscreenlist = 0;
    if ( (fp1 = fopen( gfilename, "r")) == (FILE *) 0) {
       printf("File %s NOT FOUND\r\n", gfilename);
       exit(1);
       }

    i=0;
    for (; ;) {
        if ( (c = getc(fp1)) == EOF)
           break;
        buffer[i] = c;
        buffer[i+1] = '\0';
        if (strncmp("tablehelp", buffer, strlen(buffer)) == 0) {
           if (strcmp("tablehelp", buffer) == 0) {  
               if (replacestring(fp1, buffer) < 0) { 
                  ++i;
                  continue;
                  }
               }
           else {
               ++i;
               continue;
               }
           }
        fputs( buffer, stdout);
        i=0;
        buffer[0] = '\0';
        }
    fputs( buffer, stdout);

    helpinclude();

    fclose( fp1);
}


static int replacestring(fp1, buffer)
FILE *fp1;
char *buffer;
{
    int c;
    int i;
    static char cmdargs[500];
    static char helptype[500];
    static char helpscreen[500];


    /* put replacement string into buffer */
    for (i=0; ;++i) {
        if ( (c = getc(fp1)) == EOF)
           break;
        cmdargs[i] = c;
        cmdargs[i+1] = '\0';
        if (c == ')')  
           break;
        }

    if (lookuphelpscreen(cmdargs, helptype, helpscreen) < 0)
       return(-1);

    sprintf(buffer, "%s(%s)", helptype, helpscreen);
    return(0);
}

static int lookuphelpscreen(cmdargs, helptype, helpscreen)
char *cmdargs;
char *helptype;
char *helpscreen;
{
    char *p;
    int i;

    char indexname[100];

    indexname[0] = '\0';
    for (p=cmdargs; *p != ','; ++p); /* position to first comma */
    for (i=0,++p; *p != ','; ++i,++p) /* save value after first comma */
        indexname[i] = *p; 
    indexname[i] = '\0';
    strcompress(indexname);

      for (i=0; i < n_helpstruct; ++i) {
       if (strcmp(indexname, helpstruct[i].indexname) == 0) { 
          strcpy(helptype,   helpstruct[i].helptype);
          strcpy(helpscreen,   helpstruct[i].helpscreen);
          addhelpscreenlist(helpstruct[i].helpscreen);
          break;
          }
       }

    if (i >= n_helpstruct) {
       fprintf(stderr, "TABLEHELP INDEX: %s not defined (see %s) (%d, %d)\r\n", 
              indexname, gfilename, i, n_helpstruct);
       return(-1);
       }

    return(0);
}

static int helpinclude()
{
   int i;

   for (i=0; i < n_helpscreenlist; ++i) 
       printf("#include \"%s.flx\"\n", helpscreenlist[i].helpscreen);

    return(0);
}

static int addhelpscreenlist(helpscreen)
char *helpscreen;
{

   int i;


   for (i=0; i < n_helpscreenlist; ++i) { 
      if (strcmp(helpscreenlist[i].helpscreen, helpscreen) == 0)
         break;
      }

   if (i >= n_helpscreenlist) { /* NOT FOUND - add to list */
      strcpy(helpscreenlist[n_helpscreenlist].helpscreen, helpscreen);
      ++n_helpscreenlist;
      }


}
