
   /*  drop table menuhead; */

    create table menuhead
       (menuname      char(10),
        title1        char(76),
        title2        char(76),
        prevmenu      char(10),
        template      char(18),
        ncolumns      smallint,
        nmenufields   smallint,
        format        char(1),
        urow          smallint,
        ucol          smallint,
        lrow          smallint,
        lcol          smallint
         );


   create unique index mhmenukey
        on menuhead ( menuname);



/*    drop table menufield; */

    create table menufield
       (menuname      char(10),
        itemnum       smallint,
        itemdesc      char(60),
        menufieldid   serial,
        exectype      char(1),
        execline      char(80),
        password      char(8),
        clearscr      char( 1),
        startcr       char(1),
        endcr      char(1)
         );

   create unique index mfmenukey
        on menufield ( menuname, itemnum);

    drop table menuuser onerror warning; 
    create table menuuser
       (usercode      char(10),  /* usually login name */
        usertype    char(10),
        password      char(10),
        flag1         char(1),
        flag2         char(1),
        flag3         char(1),
        description   char(25)
        );
   create unique index menuuserkey
        on menuuser (usercode);

    drop table menuusty onerror warning; 
    create table menuusty
       (usertype    char(10),
        menuname      char(10),
        password      char(10),
        osflag        char(1),
        flag1         char(1),
        flag2         char(1),
        flag3         char(1),
        description   char(25),
        flag_ctln     char(1),
        flag_ctld     char(1),
        flag_ctlp     char(1)
        );
   create unique index menuustykey
        on menuusty (usertype);


    drop table menuperm onerror warning;
    create table menuperm
       (usertype  char(10), 
        menufieldid integer,
        permtype  char(1),
        permlist  char(30),
        execline    char(30),
        password      char(10)
        );
   create unique index menupermkey
        on menuperm (usertype, menufieldid);


    insert into menuhead
         (menuname, title1, title2, prevmenu, template, ncolumns, nmenufields, urow, ucol, lrow, lcol)
       values
         ("M", "Master Menu", "", "", "", "0", "0", "0", "0", "0", "0");

    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("M", "1", "Choice #1", "P", "", "", "","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("M", "2", "Choice #2", "P", "", "", "","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
         ("M", "3", "Choice #3", "P", "", "", "","","");


insert into menuhead (menuname, title1, title2, prevmenu, template, ncolumns, nmenufields, urow, ucol, lrow, lcol) values
("D","Development Menu","","M","devmenu","","0","0","0","0","0");

    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","1","Design","P","cwmenu cwmenu2","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","2","Print","P","cwmenu cwmenur","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","3","","P","","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","4","","P","","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","5","Define User Types","P","cwmenu cwmenu2 -f menuustytable","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","6","Define Users","P","cwmenu cwmenu2 -f menuusertable","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","7","Change Password","P","cwmenu cwmenu2 -f chgpassword","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","8","","P","","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","9","","P","","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","10","","P","","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","11","Select Source","F","fxdevel x","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","12","Edit Source","F","fxdevel e","","Y","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","13","Process Source","F","fxdevel p","","Y","","Y");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","14","Compile Source","F","fxdevel c","","Y","","Y");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","15","Test Program","F","fxdevel s","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","16","Run SQL statement","F","fxdevel q","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values 
    ("D","17","Modify Central File","F","flex sysfile cda","","","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","18","Printer Control","P","flexprnt","","Y","","Y");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","19","Printer Configuration","P","flexprc","","Y","","");
    insert into menufield (menuname, itemnum, itemdesc, exectype, execline, password, clearscr, startcr,endcr) values
    ("D","20","Terminal Control","P","flexterm","","Y","","Y");




