/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/
/*F
 *    Name: prntflex.c  - Menu Driver to define terminal comntrol sequences.
 *
 *    Class: F
 *
 *    Author:  Gerard Menicucci
 *
 *    Description:
 *
 *    Returns:
 *
 *    Warnings:
 *
 */

#include "termflex.h"
#define MAXPRNT 50

TERMTBL prttbl[ MAXPRNT];
char prtseq[ MAXPRNT][ PRTSIZE];
int n_prttbl;

char asctermpath[ 256];
char bintermpath[ 256];

char cwtermpath[ 256];

static PRNTVAR prntvar;
static int initable();

main()
{
     extern char *getenv();
     char *fxdir;

     initable( &prntvar);

     cwtermpath[0] = '\0';
     if ( NULL == (fxdir = getenv( FXDIR) ) ) {
        printf( "\n\r\n\rFXDIR environment variable must be set");
        exit(0);
        }

     strcpy( cwtermpath, fxdir);
     strcat( cwtermpath, PATHSLASH);
     strcat( cwtermpath, "dev");

     printf("\r\n\r\n\r\n\r\n\r\n\r\n\r\n");

     if ( QUIT == menuterm() )
        return(0);

     readascii( &prntvar, asctermpath);

     menu( &prntvar);

}


menu( prntvar)
PRNTVAR *prntvar;
{
   char c;
   int dbreak = NO;
   char line[ 90];

   for ( ;dbreak==NO;) {

       printf("\r\n\r\n\r\n\r\n");
       printf(" P R I N T E R   S U P P O R T   M E N U (%s)\r\n", cwtermpath);
       printf(" ---------------------------------------------------------\n\n");

       printf("     1.  Assign settings\n");
       printf("     2.  Display settings.\n");
       printf("     3.  Print settings.\n");
       printf("     4.  Test settings.\n");
       printf("     5.  Save settings.\n");
       printf("     6.  Save & Install settings to %s.\n", cwtermpath);
       printf("     Q.  Quit.\n");
       printf("\n\n");
       printf("         Select Menu Option # ");

       getline( line, sizeof(line), stdin);
       c = line[0];
       switch(c) {
          case '1':
             pmtseq( prntvar);
             break;
          case '2':
             prprtseq( prntvar, DISPLAY);
             break;
          case '3':
             sprintf( line, "pr %s | lp", asctermpath);
             system(line);
             break;
          case '4':
             printf( "NOT implemented at this time\n");
             break;
          case '5':
             wrascii( prntvar, asctermpath);
             writeterm( prntvar);
             break;
          case '6':
             wrascii( prntvar, asctermpath);
             writeterm( prntvar);
             sprintf( line, "%s %s %s", CPCOMMAND, bintermpath, cwtermpath);
             system(line);
             break;
          case 'B':
             /*  Load settings from PRNTFLEX file. */
             readascii( prntvar, asctermpath);
             break;
          case 'b':
          case 'e':
          case 'E':
          case 'Q':
          case 'q':
             dbreak = YES;
             break;
          default:
             printf( "Bad entry --- Try Again");

          }
      }


    return( 0);
}




menuterm()
{
    FILE      * fp;
    char line[60];
    int    i, cc;
    char termname[20];
    extern char *getword();

 startover:
    if ((fp = fopen("prntflex.dir", "r")) == NULL) {
        printf("%s: can't open prntflex.dir\n");
        return(QUIT);
    }

    printf("\r\n\r\nSELECT PRINTER TYPE\r\n\r\n");

    for (i=1; getline(line, sizeof(line), fp) != 0; ++i)
        printf("%2d. %-30s\n", i, line);

    printf("\nEnter printer number (a=add, q=quit): ");
    getline(line, sizeof( line), stdin);
    if (*line == 'q' || *line == 'Q')
       exit(0);
    if (*line == 'a' || *line == 'A') {
       fmclose(fp);
       fxaddterm("prntflex.dir");
       goto startover;
       }
    cc = atoi(line);

    if (cc >= 1 && cc <= i) {
        rewind( fp);
        for (i=1; getline(line, sizeof(line), fp) != 0 && i < cc; ++i);
        getword( termname, line);
        strcompress( termname);
        strcpy(bintermpath, termname);
        strcpy(asctermpath, termname);
        strcat(asctermpath, ".asc");
        }
    else {
        printf("Invalid Entry\n");
        return( QUIT);
        }


    fclose(fp);

    return( 0);
}




clrseq( prntvar, opcode)
PRNTVAR *prntvar;
int opcode;
{
      int i;

     memset( (char *)*prntvar->pv_prtseq, '\0', (prntvar->pv_nprtseq * PRTSIZE));

}



static int initable( prntvar)
PRNTVAR *prntvar;
{
     int i;

     memset( (char *)prntvar, '\0', sizeof(PRNTVAR));

     /*  P R T   C O N T R O L   S E Q U E N C E S    */
     n_prttbl = MAXPRNT;
     loadtbl( "prntflex.prt", prttbl, &n_prttbl);
     prntvar->pv_nprtseq  = n_prttbl;/* assign address of first pointer */
     if ( NULL == ( prntvar->pv_prtseq = (char **)
                    calloc( prntvar->pv_nprtseq, sizeof( char *) ) ) ) {
        printf( "Insufficient Memeory");
        exit(1);
        }

     /* initialize array of pointers  */
     for ( i = 0; i < prntvar->pv_nprtseq; ++i)
         prntvar->pv_prtseq[i] = prtseq[i];

     clrseq( prntvar, NULL);


}



writeterm(prntvar)
PRNTVAR *prntvar;
{
    PRNTHDR prnthdr;
    int i, j, fd, nbytes;
        int nalloc, prtnalloc;
        char line[80];


    if (bintermpath == NULL) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

    if ( -1 == (fd = open( bintermpath,
                 (O_WRONLY | O_TRUNC | O_CREAT | O_BINARY), MODE_RAW)  ) ) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

     /* set-up TERMINAL HEADER  */
    memset((char *)&prnthdr, '\0', sizeof(PRNTHDR));

    x_shtobuf(prnthdr.ph_magic, KH_MAGIC);
    strcpy(prnthdr.ph_version, "VERSION 1.00");
    strncpy(prnthdr.ph_termname, bintermpath, sizeof( prnthdr.ph_termname) - 1);

    x_shtobuf(prnthdr.ph_nprtseq, prntvar->pv_nprtseq);

        /* set allocation count for CRT SEQUENCES */
    prtnalloc = 0;
    for (i = 0; i < prntvar->pv_nprtseq; ++i) {
        prtnalloc += strlen(prntvar->pv_prtseq[i]) + 1;
            }
    x_shtobuf(prnthdr.ph_prtnalloc, prtnalloc);

     /* write out TERMINAL HEADER  */
    nbytes = write(fd, (char *)&prnthdr, sizeof(PRNTHDR));
        if (nbytes < sizeof(PRNTHDR)) {
                printf( "Could not write TERMINAL Header");
                fflush( stdout);
        return -1;
        }


      /* write out CRT SEQUENCES */
         /* write each piece because efficiency not an issue here  */
    for (i = 0; i < prntvar->pv_nprtseq; ++i) {
        nalloc = strlen(prntvar->pv_prtseq[i]) + 1;
                nbytes = write( fd, prntvar->pv_prtseq[i], nalloc);
                if (nbytes < nalloc) {
                    printf( "Could not write CRT SEQUENCES");
                    fflush( stdout);
                return -1;
                    }

/*
                printf( "%3d.  %-30.30s  ",
                      i+1,  prttbl[i].tm_prompt);
                for (j = 0; j < nalloc; ++j)
                    printf( "%4d", prntvar->pv_prtseq[i][j] );
                printf( "\n");
*/
            }


        printf( "\r\n\r\n\r\n S A V E     S U M M A R Y \n");

        printf( " header byte count = %d\n", sizeof(PRNTHDR));
        printf( " prt byte count    = %d\n", prtnalloc);
        printf("\r\n\r\nPress RETURN key to continue...");
        getline(  line, sizeof line, stdin);
        printf("\r\n\r\n\r\n");
        fflush( stdout);

    close(fd);
    return 0;
}




pmtseq( prntvar)
PRNTVAR *prntvar;
{
    char command[ 100];
    char *editor;
    extern char *getenv();

        wrascii( prntvar, "ascterm.tmp");

        if ( NULL == ( editor = getenv( FXEDIT) ) )
            strcpy( command, EDCOMMAND);
        else
            strcpy( command, editor);

        strcat( command, " ascterm.tmp");

        if ( 0 != system( command) ) {
             printf( "error calling editor");
             fflush( stdout);
             }

        readascii( prntvar, "ascterm.tmp");

}



prprtseq( prntvar, mode)
PRNTVAR *prntvar;
int mode;
{

   printf("\n\n");
   printf(" C R T   C O N T R O L   S E Q U E N C E S (%d)\n", prntvar->pv_nprtseq);
   printseq(  prttbl, prntvar->pv_prtseq, prntvar->pv_nprtseq );

}


wrascii( prntvar, termpath)
PRNTVAR *prntvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "w"))) {
        printf( "%s file could not be opened", termpath);
        return( -1);
        }

   writecap(fp, prttbl, prntvar->pv_prtseq, prntvar->pv_nprtseq, PRTSIZE);

    fclose( fp);

}

readascii( prntvar, termpath)
PRNTVAR *prntvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "r"))) {
        printf( "%s file does not exist", termpath);
        return( -1);
        }

   clrseq( prntvar, NULL);
   readcap(fp, prttbl, prntvar->pv_prtseq, prntvar->pv_nprtseq, PRTSIZE);


   fclose( fp);



}
