/*                     - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

/*F
 *    Name: termget.c  - Prompt for keyboard sequences.
 *
 *    Class: F
 *
 *    Author:  Gerard Menicucci
 *
 *    Description:
 *
 *    Returns:
 *
 *    Warnings:
 *
 */

#include "fxstd.h"
#include "fxport.h"
#include "fxcon.h"
#include "fxcrt.h"



#ifdef UNIX

#   ifndef VAXVMS 
#       include <sys/types.h>
#       include <sys/ioctl.h>
#       ifdef UniFLEX 
#       elif  defined(USE_TERMIOS) 
#           include <termios.h>
            static struct termios oldtty;
#       else 
#           include <termio.h>
#           include <fcntl.h>
            static struct termio oldtty;
#       endif
#   endif
void sigalarm();
static int alarmflag = 0;
extern int readport;
extern int writport;
#endif


tmgetstr( keystr)
char *keystr;
{
    int i, j;
    int readflag;
    char keyhit;
#   ifdef VAXVMS
    short iosb[4];
#   endif

    setcrt();

    if (0 > (readflag = read(readport, &keyhit, 1)) ) {
        }

    i = 0;
    keystr[i] = keyhit;

    fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) | O_NDELAY);
    for (;;)  {
        readflag = read(readport, &keyhit, 1);
        if (readflag <= 0)
           break;
        /*  Diagnostics message
        printf( "%d. %d\r\n", i, keyhit); fflush( stdout);
        */
        keystr[++i] = keyhit;
        }  /* end of for loop  */
    fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) & ~O_NDELAY);

    keystr[++i] = 0;  /* null terminate  */

/**
    for (j = 0; j < 6 && keystr[j] > 0; ++j)
        printf( "%4d", keystr[j]);
    printf( "\r\n"); fflush( stdout);
**/

    resetcrt();


}


tmgetstr3( keystr)
char *keystr;
{
    int i, j;
    getline(keystr, 10, stdin);
}

tmgetstr2( keystr)
char *keystr;
{

#ifdef MSDOS
  printf( "\n\nNOT IMPLEMENTED for MSDOS\n\n");

#endif


#ifdef UNIX
    int i, j;
    int readflag;
    char keyhit;
#   ifdef VAXVMS
    short iosb[4];
#   endif

    setcrt();
    setsignal();

    for (i = 0;;)  {
        keyhit = 0;
        alarmflag = NO;
#   ifdef VAXVMS
	SYS$QIOW(0, qiochan, IO$_READVBLK|IO$M_NOFILTR|IO$M_NOECHO|IO$M_TIMED,
		&iosb, 0, 0, &keyhit, 1, 1, 0, 0, 0);

        /*  Diagnostics message
        printf( "%d. %d\r\n", i, keyhit); fflush( stdout);
        */

	if (keyhit == 0 && i > 0)
	    break;
	
	if (keyhit == 0)
	    continue;
#   else
        alarm(1);
        if (  0 > (readflag = read(readport, &keyhit, 1)) ) {
            /*
       printf("Libsys2 Read error: readflag = %d, errno %d\r\n", readflag, errno);
           */
           }
        alarm(0);

        /*  Diagnostics message
        printf( "%d. %d\r\n", i, keyhit); fflush( stdout);
        */

        if (alarmflag == YES && i > 0)
           break;

        if ( 0 > readflag)
           continue;
#   endif

        keystr[i] = keyhit;
        ++i;

        }  /* end of for loop  */


    keystr[i] = 0;  /* null terminate  */

/*
    for (j = 0; j < 6 && keystr[j] > 0; ++j)
        printf( "%4d", keystr[j]);

    printf( "\r\n"); fflush( stdout);
*/

    resetcrt();

#endif

}


#ifdef UNIX

setsignal()  /* set signals */
{
#   ifndef VAXVMS 
    signal( SIGALRM, sigalarm);
#   endif
}

void sigalarm( signo)  /* routine executed when alarm goes off  */
int signo;
{
        alarmflag = YES;
    signal( SIGALRM, sigalarm);
}

#endif
